| http://www.sim.no/ http://www.coin3d.org/

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
SoDirectionalLightManip Class Reference
Manipulator Classes

The SoDirectionalLightManip class is used to manipulate SoDirectionalLight nodes.

More...

`#include <Inventor/manips/SoDirectionalLightManip.h>`

Inheritance diagram for SoDirectionalLightManip:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoDirectionalLightManip (void)
SoDragger * | getDragger (void)
SbBool | replaceNode (SoPath *path)
SbBool | replaceManip (SoPath *path, SoDirectionalLight *newone) const
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual SoChildList * | getChildren (void) const
Public Member Functions inherited from SoDirectionalLight
| SoDirectionalLight (void)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
uint32_t | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoDirectionalLight
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoLight
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoDirectionalLightManip (void)
void | setDragger (SoDragger *newdragger)
virtual void | copyContents (const SoFieldContainer *fromfc, SbBool copyconnections)
Protected Member Functions inherited from SoDirectionalLight
virtual | ~SoDirectionalLight ()
Protected Member Functions inherited from SoLight
| SoLight (void)
virtual | ~SoLight ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
static void | transferFieldValues (const SoDirectionalLight *from, SoDirectionalLight *to)
static void | valueChangedCB (void *f, SoDragger *d)
static void | fieldSensorCB (void *f, SoSensor *d)
Static Protected Member Functions inherited from SoDirectionalLight
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoLight
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes

SoFieldSensor * | directionFieldSensor
SoFieldSensor * | colorFieldSensor
SoChildList * | children
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members

Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }
Public Attributes inherited from SoDirectionalLight
SoSFVec3f | direction
Public Attributes inherited from SoLight
SoSFBool | on
SoSFFloat | intensity
SoSFColor | color
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoDirectionalLightManip class is used to manipulate SoDirectionalLight nodes.

A manipulator is used by replacing the node you want to edit in the graph with the manipulator. Draggers are used to manipulate the node. When manipulation is finished, the node is put back into the graph, replacing the manipulator.

## Constructor & Destructor Documentation

## ◆ SoDirectionalLightManip()

SoDirectionalLightManip::SoDirectionalLightManip | ( | void |  | ) |

The constructor sets up the internal SoDiretionalLightDragger used by the manipulator.

## ◆ ~SoDirectionalLightManip()

SoDirectionalLightManip::~SoDirectionalLightManip | ( | void |  | ) |

protectedvirtual

Destructor. Clean up resources used by manipulator.

## Member Function Documentation

## ◆ getTypeId()

SoType SoDirectionalLightManip::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoDirectionalLight.

## ◆ getFieldData()

const SoFieldData * SoDirectionalLightManip::getFieldData | ( | void |  | ) | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoDirectionalLight.

## ◆ getDragger()

SoDragger * SoDirectionalLightManip::getDragger | ( | void |  | ) |

Return pointer to internal SoDirectionalLightDragger dragger.

## ◆ replaceNode()

SbBool SoDirectionalLightManip::replaceNode | ( | SoPath * | path | ) |

Replaces the node specified by path with this manipulator. The manipulator will copy the field data from the node, to make it affect the state in the same way as the node.

## ◆ replaceManip()

SbBool SoDirectionalLightManip::replaceManip | ( | SoPath * | path,
|  | SoDirectionalLight * | newone
| ) |  | const

Replaces this manipulator from the position specified by path with newnode. If newnode is `NULL`, an SoDirectionalLight will be created for you.

## ◆ doAction()

void SoDirectionalLightManip::doAction | ( | SoAction * | action | ) |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## ◆ callback()

void SoDirectionalLightManip::callback | ( | SoCallbackAction * | action | ) |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoLight.

## ◆ GLRender()

void SoDirectionalLightManip::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoDirectionalLight.

## ◆ getBoundingBox()

void SoDirectionalLightManip::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |

virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoNode.

## ◆ getMatrix()

void SoDirectionalLightManip::getMatrix | ( | SoGetMatrixAction * | action | ) |

virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

## ◆ handleEvent()

void SoDirectionalLightManip::handleEvent | ( | SoHandleEventAction * | action | ) |

virtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also overrides this method.

Reimplemented from SoNode.

## ◆ pick()

void SoDirectionalLightManip::pick | ( | SoPickAction * | action | ) |

virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

## ◆ search()

void SoDirectionalLightManip::search | ( | SoSearchAction * | action | ) |

virtual

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction – if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
  SoSearchAction

Reimplemented from SoNode.

## ◆ getChildren()

SoChildList * SoDirectionalLightManip::getChildren | ( | void |  | ) | const

virtual

Returns the children of this node. This node only has the dragger as a child.

Reimplemented from SoNode.

## ◆ setDragger()

void SoDirectionalLightManip::setDragger | ( | SoDragger * | newdragger | ) |

protected

Set dragger to be used by this manipulator.

## ◆ copyContents()

void SoDirectionalLightManip::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections
| ) |  |

protectedvirtual

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc etc)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}

Reimplemented from SoNode.

## ◆ transferFieldValues()

void SoDirectionalLightManip::transferFieldValues | ( | const SoDirectionalLight * | from,
|  | SoDirectionalLight * | to
| ) |  |

staticprotected

Copies field values.

## ◆ valueChangedCB()

void SoDirectionalLightManip::valueChangedCB | ( | void * | m,
|  | SoDragger * | dragger
| ) |  |

staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Convert from matrix to direction.

## ◆ fieldSensorCB()

void SoDirectionalLightManip::fieldSensorCB | ( | void * | m,
|  | SoSensor * | d
| ) |  |

staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## Member Data Documentation

## ◆ directionFieldSensor

SoFieldSensor * SoDirectionalLightManip::directionFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ colorFieldSensor

SoFieldSensor * SoDirectionalLightManip::colorFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ children

SoChildList * SoDirectionalLightManip::children

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoDirectionalLightManip.h
- SoDirectionalLightManip.cpp
- commoncode.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.